#include <bits/stdc++.h>

using namespace std;

void solve();
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
const int MAXN = 15;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int a[MAXN][MAXN];
int ft[MAXN][MAXN * 4];

void build (int i, int t, int l, int r) {
    if (r - l == 1) {
        ft[i][t] = a[i][l];
        return;
    }
    int m = (r + l) / 2;
    build (i,t * 2,l,m);
    build (i,t * 2 + 1,m,r);
    ft[i][t] = ft[i][t * 2] + ft[i][t * 2 + 1];
}

void add(int i,int t, int l, int r, int x, int y) {
    if (r - l == 1) {
        ft[i][t] += y;
        return;
    }
    int m = (r + l) / 2;
    if (x < m) {
        add(i,t * 2,l,m,x,y);
    } else {
        add(i,t * 2 + 1,m,r,x,y);
    }
    ft[i][t] = ft[i][t * 2] + ft[i][t * 2 + 1];
}

bool used1[MAXN];
bool used2[MAXN];

vector<pair<int,int>>an;
vector<pair<int,int>>now;
bool fl = false;

vector<int>p1, p2;

void rec(int h, int w, int sum, int s) {
    if (fl)return;
    if (sum == s) {
        fl = true;
        an = now;
        return;
    }
    for (int ind = 0; ind < h; ind++) {
        int i = p1[ind];
        if (used1[i])continue;
        int suma = ft[i][1];
        if (sum - suma < s) {
            continue;
        }
        used1[i]=1;
        now.push_back({1,i});
        rec(h,w,sum-suma,s);
        if (fl) return;
        now.pop_back();
        used1[i]=0;
    }
    for (int ind = 0; ind < w; ind++) {
        int i = p2[ind];
        if (used2[i]) continue;
        int ss = 0;
        for (int j = 0; j < h; j++) {
            if (used1[j]) continue;
            ss += a[j][i];
        }
        if (sum - ss < s) continue;
        used2[i]=1;
        for (int ji = 0; ji < h; ji++) {
            int j = p1[ji];
            if (used1[j])continue;
            add(j, 1,0,w, i,-a[j][i]);
        }
        now.push_back({2,i});
        rec(h,w,sum - ss, s);
        if (fl) return;
        now.pop_back();
        used2[i]=0;
        for (int j = 0; j < h; j++) {
            if (used1[j])continue;
            add(j,1,0,w,i,a[j][i]);
        }
    }

}

void solve(){
    int h, w;
    cin >> h >> w;
    int ss = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> a[i][j];
            ss += a[i][j];
        }
    }
    for (int i = 0; i < w; i++) {
        p2.push_back(i);
    }
    for (int i = 0; i < h; i++) {
        p1.push_back(i);
    }

    shuffle(p1.begin(), p1.end(),rnd);
    shuffle(p2.begin(), p2.end(),rnd);

    int s;
    cin >> s;
    for (int i = 0; i < h; i++) {
        build(i,1,0,w);
    }

    rec(h,w,ss,s);
    if (fl) {
        cout << "YES\n";
        cout << an.size() << '\n';
        for (auto i : an) {
            cout << i.first << ' ' << i.second + 1 << '\n';
        }
    } else {
        cout << "NO";
    }

}
