#include <bits/stdc++.h>
//#pragma GCC optimize (O3)
using namespace std;

void solve();
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}


const int MAXN = 2e5, INF = 2e9;

using ll = long long;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int>gr[MAXN];
int h[MAXN];
int dp[MAXN];
vector<int>onl[MAXN];
int m = -INF;
void dfs(int v, int p, int d) {
    h[v] = d;
    m = max(m, d);
    dp[v] = d;
    for (int i : gr[v]) {
        if (i == p) continue;
        dfs(i,v,d+1);
        dp[v] = max(dp[v], dp[i]);
    }
    onl[h[v]].push_back(dp[v]);
}

void solve(){
    int n, k, t;
    cin >> n >> k >> t;

    for (int i = 0; i < n-1; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    dfs(0,0,0);
    if (k == 1) {
        int ans = m;
        for (int i = 1; i <= m; i++) {
            int mx1=-INF, mx2 = -INF;
            for (int j = 0; j < (int)onl[i].size(); j++) {
                if (onl[i][j] > mx1) {
                    mx2 = mx1;
                    mx1 = onl[i][j];
                } else if (onl[i][j] == mx1) {
                    mx2 = mx1;
                } else if (onl[i][j] > mx2) {
                    mx2 = onl[i][j];
                }
            }
            if (mx2 == -INF) {
                ans = min(ans, max(mx1 - i + 1, i-1));
            } else {
                ans = min(ans, max(mx1 - i + 1, max(i-1,mx2)));
            }
        }
        cout << ans;
    } else {
        queue<pair<int,int>>st;
        st.push({-1,n-1});
        while (k > 0 && !st.empty()) {
            auto i=st.front();
            st.pop();
            int l = i.first;
            int r = i.second;
            int ll = 0, rr = r - l;
            int mid = rr / 2 + 1;
            k--;
            gr[0].push_back(mid);
            st.push({l,mid});
            st.push({mid, r});
        }

        vector<int>dist(n,INF);
        dist[0]=0;
        deque<int>qq;
        qq.push_back(0);
        while (!qq.empty()) {
            int v =qq.front();
            qq.pop_front();
            for (int i : gr[v]) {
                if (h[i] < h[v]) continue;
                if (dist[i] > dist[v] + 1) {
                    dist[i] = dist[v] + 1;
                    qq.push_back(i);
                }
            }
        }
        int nn = -INF;
        for (int i : dist) {
            nn = max(nn,i);
        }
        cout << nn;
    }

}