#include <bits/stdc++.h>
//#pragma GCC optimize (O3)
using namespace std;

void solve();
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}


const int MAXN = 2e5, INF = 2e9;
#define int int_fast32_t
using ll = long long;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int>gr[MAXN];




void solve(){
    int n, k, t;
    cin >> n >> k >> t;

    for (int i = 0; i < n-1; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    int ans = INF;
    for (int i = 1; i < n; i++) {
        gr[0].push_back(i);
        vector<int>d(n, INF);
        d[0]=0;
        deque<int>q;
        q.push_back(0);
        while (!q.empty()) {
            int v = q.front();
            q.pop_front();
            for (int u : gr[v]) {
                if (d[u] < d[v] + 1) {
                    d[u] = d[v] + 1;
                    q.push_back(u);
                }
            }
        }
        int mx = -INF;

        for (int v = 0; v < n; v++) {
            mx = max(mx, d[v]);
        }
        ans = min(ans, mx);
        gr[0].pop_back();
    }
    cout << ans;
}