#include <bits/stdc++.h>
using namespace std;


void solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}


#define int long long

const int INF = 2e9, MAXN = 1e5;

struct T{
    int x=0, ad=-INF;
};

T tree[MAXN * 4];

void build (int t, int l, int r) {
    if (r - l == 1) {
        tree[t] = {-1,-INF};
        return;
    }
    int m = (r + l) / 2;
    build (t * 2,l,m);
    build (t * 2 + 1,m,r);

}

void push(int t) {
    if (tree[t].ad != -INF) {
        tree[t * 2].ad = tree[t].ad;
        tree[t * 2 + 1].ad = tree[t].ad;
        tree[t * 2].x = tree[t].ad;
        tree[t * 2 + 1].x=tree[t].ad;
        tree[t].ad = -INF;
    }
}

void sett(int t,int l,int r,int tl, int tr, int x) {
    if (tl >= l && tr <= r) {
        tree[t].x = x;
        tree[t].ad = x;
        return;
    }
    if (tl >=r || tr <= l)return;
    push(t);
    int m = (tl + tr) / 2;
    sett(t * 2,l,r,tl,m,x);
    sett(t * 2 + 1,l,r,m,tr,x);
}

int get(int t, int l, int r, int x) {
    if (r - l == 1) {
        return tree[t].x;
    }
    push(t);
    int m = (r + l) / 2;
    if (x < m) {
        return get(t*2,l,m,x);
    } else {
        return get(t * 2 + 1,m,r,x);
    }
}

pair<int,int> gr[MAXN];
vector<int> now;
unordered_map<int,int>ans;


void dfs(int v, int n) {
    int b = get(1,0,n,v);
    if (b == -1) {
        now.push_back(v);
        ans[v] = (int)now.size();
        if (gr[v].first >= 0) dfs(gr[v].first,n);
        if (gr[v].second >= 0) dfs(gr[v].second,n);
        return;
    }
    if (b == 0) {
        if (gr[v].first >= 0) dfs(gr[v].first,n);
        now.push_back(v);
        ans[v] = (int)now.size();
        if (gr[v].second >= 0) dfs(gr[v].second,n);
        return;
    }
    if (b == 1 ){
        if (gr[v].first >= 0) dfs(gr[v].first,n);
        if (gr[v].second >= 0) dfs(gr[v].second,n);
        now.push_back(v);
        ans[v] = (int)now.size();
        return;
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[i] = {v,u};
    }
    build(1,0,n);
    dfs(0,n);
    if (n <= 5000) {
        while (q--) {
            int x;
            cin >> x;
            if (x == 1) {
                int l, r;
                cin >> l >> r;
                l--;
                int y;
                cin >> y;
                sett(1,l,r,0,n,y);
                now.clear();
                dfs(0,n);
            } else {
                int y;
                cin >> y;
                cout << ans[y-1] << '\n';
            }
        }
    } else {
        bool fl = false;
        while (q--) {
            int x;
            cin >>x;
            if (x == 1) {
                int l, r;
                cin >> l >> r;
                l--;
                int y;
                cin >> y;
                sett(1,l,r,0,n,y);
            } else {
                int y;
                cin >> y;
                if (!fl) {
                    now.clear();
                    dfs(0,n);
                    fl = true;
                }
                cout << ans[y-1] << '\n';
            }
        }
    }

}