#include <bits/stdc++.h>

using namespace std;

void solve();
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}

#define int int_fast64_t
const int MAXN = 15;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

double tim = clock();

int a[MAXN][MAXN];
bool used1[MAXN];
bool used2[MAXN];
int sui[MAXN];
vector<pair<int,int>>an;
vector<pair<int,int>>now;
bool fl = false;

vector<int>p1, p2;

void rec(int h, int w, int sum, int s) {
    if (fl)return;
    if (sum == s) {
        fl = true;
        an = now;
        return;
    }
    for (int ind = 0; ind < h; ind++) {
        double end = clock();
        if ((end - tim) / CLOCKS_PER_SEC >= 0.99) {
            cout << "NO";
            exit(0);
        }
        int i = p1[ind];
        if (used1[i])continue;
        int suma = sui[i];
        if (sum - suma < s) {
            continue;
        }
        used1[i]=1;
        now.emplace_back(make_pair(1,i));
        rec(h,w,sum-suma,s);
        if (fl) return;
        now.pop_back();
        used1[i]=0;
    }
    for (int ind = 0; ind < w; ind++) {
        double end = clock();
        if ((end - tim) / CLOCKS_PER_SEC >= 0.99) {
            cout << "NO";
            exit(0);
        }
        int i = p2[ind];
        if (used2[i]) continue;
        int ss = 0;
        for (int j = 0; j < h; j++) {
            if (used1[j]) continue;
            ss += a[j][i];
        }
        if (sum - ss < s) continue;
        used2[i]=1;
        for (int ji = 0; ji < h; ji++) {
            int j = p1[ji];
            if (used1[j])continue;
            sui[j] -= a[j][i];
        }
        now.emplace_back(make_pair(2,i));
        rec(h,w,sum - ss, s);
        if (fl) return;
        now.pop_back();
        used2[i]=0;
        for (int j = 0; j < h; j++) {
            if (used1[j])continue;
            sui[j] += a[j][i];
        }
    }

}

void solve(){
    int h, w;
    cin >> h >> w;
    int ss = 0;
    for (int i = 0; i < h; i++) {
        int x= 0;
        for (int j = 0; j < w; j++) {
            cin >> a[i][j];
            ss += a[i][j];
            x += a[i][j];
        }
        sui[i]=x;
    }
    for (int i = 0; i < w; i++) {
        p2.push_back(i);
    }
    for (int i = 0; i < h; i++) {
        p1.push_back(i);
    }

    shuffle(p1.begin(), p1.end(),rnd);
    shuffle(p2.begin(), p2.end(),rnd);

    int s;
    cin >> s;
    if (ss < s) {
        cout << "NO";
        return;
    } else if (ss == s) {
        fl = true;
    }
    rec(h,w,ss,s);
    if (fl) {
        cout << "YES\n";
        cout << an.size() << '\n';
        for (auto i : an) {
            cout << i.first << ' ' << i.second + 1 << '\n';
        }
    } else {
        cout << "NO";
    }

}