#include <bits/stdc++.h>
#pragma GCC optimize (O3)
using namespace std;

void solve();
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}


const int MAXN = 15;
#define int int_fast32_t
using ll = long long;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
long double tim = clock();
int a[MAXN][MAXN];
bool used1[MAXN];
bool used2[MAXN];
ll sui[MAXN];
ll suj[MAXN];
vector<int>del;
vector<pair<int,int>>an;
vector<pair<int,int>>now;
bool fl = false;

vector<int>p1, p2;

void rec(int h, int w, ll sum, ll s) {
    if (fl)return;
    if (sum == s) {
        fl = true;
        an = now;
        return;
    }
    for (int i : p1) {
        long double end = clock();
        if ((end - tim) / CLOCKS_PER_SEC >= 0.99) {
            cout << "NO";
            exit(0);
        }
        if (used1[i])continue;
        ll suma = sui[i];
        if (sum - suma < s) {
            continue;
        }
        used1[i]=1;
        now.emplace_back(make_pair(1,i));
        del.emplace_back(i);
        rec(h,w,sum-suma,s);
        if (fl) return;
        del.pop_back();
        now.pop_back();
        used1[i]=0;
    }
    for (int i : p2) {
        long double end = clock();
        if ((end - tim) / CLOCKS_PER_SEC >= 0.99) {
            cout << "NO";
            exit(0);
        }
        if (used2[i]) continue;
        ll ss = 0;
        for (int j : del) {
            ss -= a[j][i];
        }
        ss += suj[i];
        if (sum - ss < s) continue;
        used2[i]=1;
        for (int j : p1) {
            if (used1[j])continue;
            sui[j] -= a[j][i];
        }
        now.emplace_back(make_pair(2,i));
        rec(h,w,sum - ss, s);
        if (fl) return;
        now.pop_back();
        used2[i]=0;
        for (int j : p1) {
            if (used1[j])continue;
            sui[j] += a[j][i];
        }
    }

}

void solve(){
    int h, w;
    cin >> h >> w;
    int ss = 0;
    vector<pair<ll,int>>v1,v2;
    for (int i = 0; i < h; i++) {
        ll x= 0;
        for (int j = 0; j < w; j++) {
            cin >> a[i][j];
            ss += a[i][j];
            x += a[i][j];
        }
        sui[i]=x;
        v1.emplace_back(make_pair(x,i));
    }
    for (int j = 0; j < w; j++) {
        ll s = 0;
        for (int i = 0; i < h; i++) {
            s += a[i][j];
            suj[j] += a[i][j];
        }
        v2.emplace_back(make_pair(s,j));
    }
    sort(v1.rbegin(), v1.rend());
    sort(v2.rbegin(), v2.rend());
    for (int i = 0; i < h; i++) {
        p1.emplace_back(v1[i].second);
    }
    for (int i = 0; i < w; i++) {
        p2.emplace_back(v2[i].second);
    }
    ll s;
    cin >> s;
    if (ss < s) {
        cout << "NO";
        return;
    } else if (ss == s) {
        fl = true;
    }
    rec(h,w,ss,s);
    if (fl) {
        cout << "YES\n";
        cout << an.size() << '\n';
        for (auto i : an) {
            cout << i.first << ' ' << i.second + 1 << '\n';
        }
    } else {
        cout << "NO";
    }

}