#include <bits/stdc++.h>
//#pragma GCC optimize (O3)
using namespace std;

void solve();
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}


const int MAXN = 2e5, INF = 2e9;
#define int int_fast32_t
using ll = long long;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int>gr[MAXN];
int h[MAXN];
void dfs(int v, int p, int d) {
    h[v] = min(d,h[v]);
    for (int i : gr[v]) {
        if (i == p) continue;
        dfs(i,v,d + 1);
    }
}


void solve(){
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n; i++) {
        h[i] = INF;
    }

    for (int i = 0; i < n-1; i++) {
        int v, u;
        cin >> v >> u;
        v--;u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    dfs(0,0,0);
    int mx = -INF, ind;
    for (int i = 0; i < n; i++) {
        if (mx < h[i])  {
            mx = h[i];
            ind = i;
        }
    }
    h[ind] = 1;
    dfs(ind, ind, 1);
    int ans = -INF;
    for (int i = 0; i < n; i++) {
        ans = max(ans, h[i]);
    }
    cout << ans;
}